package sensor

import (
	"encoding/json"
	"git.loafle.net/overflow/commons_go/model/timestamp"
	"git.loafle.net/overflow/overflow_service/proxy/meta"
	"git.loafle.net/overflow/overflow_service/proxy/target"
	"git.loafle.net/overflow/overflow_service/proxy/utils"
)

type Sensor struct {
	Id                json.Number           `json:"id,Number,omitempty"`
	CreateDate        timestamp.Timestamp   `json:"createDate,omitempty"`
	Description       string                `json:"description,omitempty"`
	MetaSensorStatus  meta.MetaSensorStatus `json:"status,omitempty"`
	Target            target.Target         `json:"target,omitempty"`
	Crawler           meta.MetaCrawler      `json:"crawler,omitempty"`
	CrawlerInputItems string                `json:"crawlerInputItems,omitempty"`
}

type SensorService struct {
}

func NewSensorService() *SensorService {
	return &SensorService{}
}

func (ss *SensorService) Create(s *Sensor) (string, error) {
	out, err := utils.InvokeDB("sensor", "create", s)

	if err != nil {
		return "", err
	}
	return out, nil
}

func (ss *SensorService) List(t *target.Target) (string, error) {

	out, err := utils.InvokeDBByModel("sensor", "findAllByTargetId", t, "com.loafle.overflow.target.model.Target")

	if err != nil {
		return "", err
	}

	return out, nil

}
